package be.iminds.ilabt.jfed.espec.model;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;

/**
 * ExperimentSpecificationBuilder
 */
public interface ExperimentSpecificationBuilder<B extends ExperimentSpecificationBuilder> {
    @Nonnull B setVersion(@Nonnull String versionFull);
    @Nonnull B setVersionBase(@Nonnull String versionBase);
    @Nonnull B setVersionFlavor(@Nonnull ExperimentSpecification.Flavor versionFlavor);
    @Nonnull B setExtensions(@Nonnull List<String> extensions);
    @Nonnull B setRspecs(@Nonnull List<RspecSpec> rspecs);
    @Nonnull B addRspecs(@Nonnull List<RspecSpec> rspecs);
    @Nonnull B setRspec(@Nonnull RspecSpec rspecs);
    @Nonnull B addRspec(@Nonnull RspecSpec rspecs);
    @Nonnull B setDirs(@Nonnull List<DirSpec> dirs);
    @Nonnull B addDir(@Nonnull DirSpec dir);
    @Nonnull B addDirs(@Nonnull List<DirSpec> dirs);
    @Nonnull B setUploads(@Nonnull List<UploadSpec> uploads);
    @Nonnull B addUpload(@Nonnull UploadSpec upload);
    @Nonnull B addUploads(@Nonnull List<UploadSpec> uploads);
    @Nonnull B setExecutes(@Nonnull List<ExecuteSpec> executes);
    @Nonnull B addExecute(@Nonnull ExecuteSpec execute);
    @Nonnull B addExecutes(@Nonnull List<ExecuteSpec> executes);
    @Nonnull B setAnsible(@Nullable AnsibleSpec ansible);
    @Nonnull ExperimentSpecification create();

    @Nullable AnsibleSpec getAnsible();
}
